! Subs atom to atom (with resdiue types) (2 parameter)
! Eshel Faraggi 01/2012 (c)

module temp
  integer naatyp
  integer i, j, k, n, nres, ipo
  double precision tmp
  character*300 pdbfl, depfl
  character*10, allocatable :: aatom(:,:)
  integer, allocatable :: iaa(:)
  double precision, allocatable :: pdat(:,:)
end module
!_______________________________________________________________________
!--
      subroutine initall()
      use temp
      implicit none
      integer iaa2i, nargs,icrd
      double precision xc(3)
      character tc1*10, tc2*10, tc3*10, tc4*10, arg*300, tmpfl*300
      
      !read command line
      pdbfl = ""
      depfl = "aa_atom.types"
      nargs=iargc()
      if (nargs.ge.1) then
        icrd = 1
!       Switches:
        do while (icrd.le.nargs)
          call getarg(icrd,arg)
          if (arg.eq."-dp") then                !build db
            call getarg(icrd+1,tmpfl)
            pdbfl = trim(tmpfl)
            !write(*,'(1x,130(A),1x)',advance='no') trim(arg), " ", trim(tmpfl)
          elseif (arg.eq."-t") then          !types file
            call getarg(icrd+1,tmpfl)
            depfl = trim(tmpfl)
            !write(*,'(1x,130(A),1x)',advance='no') trim(arg), " ", trim(tmpfl)
          elseif (arg.eq."-h") then
            call printhelp()
            stop
          endif
          icrd = icrd + 1
        enddo
      else
            call printhelp()
            stop
      endif
      
      open(22,file=depfl,status='old')
      i = 0
      do while(i.ge.0)
        i = i + 1
        read(22,*,end=101)
      enddo
101   continue
      naatyp = i
      allocate( aatom(2,naatyp) )
      rewind(22)
      i = 0
      do while(i.ge.0)
        i = i + 1
        read(22,*,end=111) aatom(1,i), aatom(2,i)
      enddo
      close(22)
111   continue

      if (pdbfl.ne."") then
        nres = 200000
        k = 1
        allocate( iaa(nres), pdat(2,nres) )
        !read file
        tmpfl = trim(pdbfl)//"-residue.depth"
        open(unit=22,file=tmpfl,status='old')
        tmpfl = trim(pdbfl)//"-atom.depth"
        open(unit=23,file=tmpfl,status='old')
        read(22,*)
        read(23,*)
        
        i = 1
        read(22,*,end=121) tc2,tc1
        do while(i.gt.0)
          read(23,*,end=121) arg, tc3, tc4, (xc(n),n=1,2)
          if (tc2.eq.tc3) then
            do n=1,2
              pdat(n,i) = 1.d0 * xc(n)
            enddo
            iaa(i) = iaa2i(tc1,tc4)
            i = i + 1
          else
            read(22,*,end=121) tc2,tc1
            if (tc2.eq.tc3) then
              do n=1,2
                pdat(n,i) = 1.d0 * xc(n)
              enddo
              iaa(i) = iaa2i(tc1,tc4)
              i = i + 1
            else
              write(0,*) "Strings for residues don't match for ",trim(tmpfl)
              stop
            endif
          endif
        enddo
121     continue
        close(22)
        close(23)
        nres = i - 1
        ipo = 1
        if (i.le.1) then
          write(0,*) "Aborting, nres problem."
          stop
        endif
        call e2rr(nres,pdat(1,ipo),iaa(ipo))
      endif
      
      end
!_______________________________________________________________________
!--
      subroutine printhelp()
      use temp
      implicit none
      
      print*, "Distance matrix . Step 1+2"
      print*, "Eshel Faraggi, efaraggi@gmail.com"
      print*, "You Must Obtain License from above address to USE this program"
      write(*,*) " prints parmaters for distance atom_res to atom_res"
      print*, "Options:"

      write(*,'(A10,3x,A30,10x,A20)') "Switch","Description", "Default"
      write(*,'(A10,3x,A30,10x,A20)') "-dp","deppdbfile", "NONE"
      write(*,'(A10,3x,A30,10x,A120)') "-t","typefile", depfl
      write(*,'(A10,3x,A30,10x,A20)') "-h","print_this_help"
      write(*,*) 
      write(*,*) "Program to calculate inverse distance inputs to NN."

      end
!_______________________________________________________________________
!--
      subroutine e2rr(ivsize,v,jaa)
      use temp
      implicit none
      integer ivsize, jaa(ivsize)
      double precision v(2,ivsize), qpar(2,naatyp), qpar3(naatyp)
      integer iqpar(naatyp)

      do i=1,naatyp
          qpar(1,i) = 0.d0
          qpar(2,i) = 0.d0
          qpar3(i) = 0.d0
          iqpar(i) = 0
      enddo
      do i=1,ivsize
          tmp = v(1,i)
          if (tmp.gt.0.d0) then
            qpar(1,jaa(i)) = qpar(1,jaa(i)) + 1.d0 / tmp
            qpar(2,jaa(i)) = qpar(2,jaa(i)) + v(2,i)
            qpar3(jaa(i)) = qpar3(jaa(i)) + 1.d0/ (tmp*tmp*tmp)
            iqpar(jaa(i)) = iqpar(jaa(i)) + 1
          else
            write(0,*) "Aborting, weird distance ", i,tmp
            stop
          endif
      enddo
      tmp = (1.d0*ivsize)**(1.d0/3)
      
      do i=1,naatyp
        write(*,*) (qpar(j,i)/tmp,j=1,2), qpar3(i)/tmp, iqpar(i)/(1.d0*ivsize)
      enddo

      end
!_______________________________________________________________________
!--
      integer function iaa2i(caa, daa)
      use temp
      implicit none
      integer ii
      character*10 caa, daa
      
      iaa2i = naatyp
      do ii=1,naatyp - 1
        if ((caa.eq.aatom(1,ii)).and.(daa.eq.aatom(2,ii))) iaa2i = ii
      enddo
      if (iaa2i.eq.naatyp) then
        write(0,*) "Unknown type ", caa, daa
!        stop
      endif
      
      end
!_______________________________________________________________________
